SLBM: taup::TPVelocityLayer Class Reference

SLBM 3.0 Regional Seismic Travel Time

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
taup::TPVelocityLayer Class Reference

Abstract base class velocity layer model inherited by all concrete velocity layer classes. The inheritance hierarchy for a typical velocity layer object, VL, is: More...

`#include <TPVelocityModels.h>`

Inherited by taup::VelocityIntegrate< V >, taup::VelocityIntegrate< VelocityConst >, taup::VelocityIntegrate< VelocityCubic >, taup::VelocityIntegrate< VelocityLinear >, taup::VelocityIntegrate< VelocityPower >, and taup::VelocityIntegrate< VelocityQuadratic >.

## Public Member Functions
| TPVelocityLayer ()
| Default constructor. Sets top and bottom layer radius to zero. More...
| TPVelocityLayer (double rt, double rb, const string &layrnam)
| TPVelocityLayer (const TPVelocityLayer &vl)
| Copy constructor. More...
virtual | ~TPVelocityLayer ()
| Destructor. More...
TPVelocityLayer & | operator= (const TPVelocityLayer &vl)
| Assignment Operator. More...
virtual double | operator() (double r)
void | init ()
| Initializes the velocity layer evaluating vlVt, vlVb, vlPt, and vlPb;. More...
virtual void | writeNormRadius (ostream &os) const
| Used to write the normalized radius parameter (if defined) to a CLR output stream os. More...
virtual void | writeVelocity (ostream &os) const
| Used to write the CLR formatted velocity profile to the input output stream os. More...
virtual double | rAtP (double p)
double | pAtR (double r)
double | integDistance (double p, double r=-1.0)
| The distance integration function which gives the distance of the ray travel from the surface of the Earth to the ray turning depth as a function of the ray parameter p (slowness). The integration terminates before the turning depth if the radius r is positive. More...
double | integDistance (double p, double r1, double r2)
| The distance integration function which gives the distance of the ray travel from radius r1 to radius r2 as a function of the ray parameter p (slowness). The integration terminates at the turning depth if that occurs before reaching r2. More...
double | integTime (double p, double r=-1.0)
| The time integration function which gives the time of the ray travel from the surface of the Earth to the ray turning depth as a function of the ray parameter p (slowness). The integration terminates before the turning depth if the radius r is positive. More...
double | integTime (double p, double r1, double r2)
| The time integration function which gives the time of the ray travel from radius r1 to radius r2 as a function of the ray parameter p (slowness). The integration terminates at the turning depth if that occurs before reaching r2. More...
virtual double | integrateDistance (double p, double ra, bool r_open=false)
| The distance integration function that calculates the ray travel distance from the start of the layer boundary (vlRt) to depth r given the input ray parameter p. This function is defined by super classes of this object. More...
virtual double | integrateDistance (double p, double ra, double rb, bool r_open=false)
| The distance integration function that calculates the ray travel distance from the start of the layer boundary (vlRt) to depth r given the input ray parameter p. This function is defined by super classes of this object. More...
virtual double | integrateTime (double p, double ra)
| The time (or tau) integration function that calculates the ray travel time from the start of the layer boundary (vlRt) to depth r given the input ray parameter p. This function is defined by super classes of this object. More...
virtual double | integrateTime (double p, double ra, double rb)
| The time (or tau) integration function that calculates the ray travel time from the start of the layer boundary (vlRt) to depth r given the input ray parameter p. This function is defined by super classes of this object. More...
virtual bool | isTimeIntegralTau () const
| The Default time integral is really Tau function which must be added to p * distance. Override this function to return false if the time integral returns time and not tau. More...
double | getRt () const
| Returns the top of the layer radius. More...
double | getRb () const
| Returns the bottom of the layer radius. More...
double | getVt () const
| Returns the top of the layer velocity. More...
double | getVb () const
| Returns the bottom of the layer velocity. More...
double | getPt () const
| Returns the top of the layer ray parameter (slowness). More...
double | getPb () const
| Returns the bottom of the layer ray parameter (slowness). More...
double | getTurningRadius () const
double | getTurningVelocity () const
void | setPmin (double pmin)
| Sets the minimum ray parameter for the layer. If less than getPt() then the top half of the layer is shadowed. More...
double | getPmin () const
| Returns the minimum passing ray parameter for the layer. if less than getPt() then the top half of the layer is shadowed. More...
void | setDistT (double d)
| Sets the accumulated distance through all layers upto the top of this layer given a ray parameter of vlPt() or vlPmin(), whichever is smaller. More...
double | getDistT () const
| Returns the accumulated distance through all layers upto the top of this layer given a ray parameter of vlPt() or vlPmin(), whichever is smaller. More...
void | setDistB (double d)
| Sets the accumulated distance through all layers including this one given a ray parameter of vlPb() or vlPmin(), whichever is smaller. More...
double | getDistB () const
| Returns the accumulated distance through all layers including this one given a ray parameter of vlPb() or vlPmin(), whichever is smaller. More...
void | setdDistdPT (double dDdP)
| Sets the derivative of the distance wrt. the ray parameter at the top of the layer. More...
double | getdDistdPT () const
| Returns the derivative of the distance wrt. the ray parameter at the top of the layer. More...
void | setdDistdPB (double dDdP)
| Sets the derivative of the distance wrt. the ray parameter at the bottom of the layer. More...
double | getdDistdPB () const
| Returns the derivative of the distance wrt. the ray parameter at the bottom of the layer. More...
void | setLayerType (int lt)
int | getLayerType () const
const string & | getLayerName () const
| Returns the descriptive layer name. More...
void | setPhaseTypeP ()
| Sets the layer phase type to "P". More...
void | setPhaseTypeS ()
| Sets the layer phase type to "S". More...
void | setPhaseType (const string &phtype)
| Sets the layer phase type to phtype. More...
const string & | getPhaseType () const
| Returns the layer phase type string. More...
void | setPhaseName (const string &name)
| Sets the layer default phase name. More...
const string & | getPhaseName () const
| Returns the layer default phase name. More...
void | setPhaseNameUpper (const string &name)
| Sets the upper phase name if the layer is a retrograde layer. More...
const string & | getPhaseNameUpper () const
| Returns the upper phase name if the layer is a retrograde layer. More...
void | setPhaseNameLower (const string &name)
| Sets the lower phase name if the layer is a retrograde layer. More...
const string & | getPhaseNameLower () const
| Returns the lower phase name if the layer is a retrograde layer. More...
void | setPhaseNameDiff (const string &name)
| Sets the upper interface phase name. More...
const string & | getPhaseNameDiff () const
| Returns the upper interface phase name if assigned. More...
void | setPhaseNameDiffLower (const string &name)
| Sets the lower interface phase name. More...
const string & | getPhaseNameDiffLower () const
| Returns the lower interface phase name if assigned. More...
void | setPhaseDiffDef (bool def)
| Sets the upper diffracted wave phase for this layer to true even if it has no formal phase name definition. This will default to use the default evaluated names of X::i+ where # is the layer # and X is "P" or "S". More...
void | setPhaseDiffLowerDef (bool def)
| Sets the lower diffracted wave phase for this layer to true even if it has no formal phase name definition. This will default to use the default evaluated names of X::i- where # is the layer # and X is "P" or "S". More...
bool | isPhaseDiffDefined () const
| Returns true if the upper diffracted phase is defined for this layer. More...
bool | isPhaseDiffLowerDefined () const
| Returns true if the lower diffracted phase is defined for this layer. More...
double | getPCrit () const
double | getDistCrit () const
bool | isSplitLayer () const
| Returns true if the layer is a retrograde layer. More...
void | setSplitLayer (double pcrit, double dcrit)
| Sets the layers retrograde parameters if the layer was found to contain a retrograde minimum. More...
bool | invalidRay () const
| Returns true if the last evaluated ray parameter was unable to pass through this layer. More...
bool | passingRay () const
| Returns true if the last evaluated ray parameter passed through this layer. More...
bool | turningRay () const
| Returns true if the last evaluated ray parameter produced a turning ray in this layer. More...
string | toString () const
| Print object data to string. More...
virtual void | toStream (ostream &os, string indent) const
| Print object data to input stream os. More...
virtual string | get_class_name () const
| Virtual function that returns the class name. More...
virtual int | classSize () const
| Returns the class size. More...
virtual bool | isVelocityConstant () const
virtual bool | isVelocityPowerLaw () const
virtual bool | isVelocityLinear () const
virtual bool | isVelocityQuadratic () const
virtual bool | isVelocityCubic () const
virtual int | bufferSize () const
virtual void | serialize (DataBuffer &buffer)
virtual void | deserialize (DataBuffer &buffer)

## Static Public Member Functions
static TPVelocityLayer * | newModelCopy (TPVelocityLayer *tpvl)
| TPVelocityLayer factory method that returns a new TPVelocityLayer object copied from the input object tpvl. More...
static TPVelocityLayer * | newModelCopy (const string &cnam, DataBuffer &buffer)
| TPVelocityLayer factory method that returns a new TPVelocityLayer object of derived type name, /em cnam. The data used to define the layer is given in the DataBuffer buffer. More...
static string | class_name ()
| Static function that returns the class name. More...

## Protected Member Functions
void | setRay (double p)
| Sets the ray as invalid, passing, or turning given an input ray parameter p. This function also sets the turning radius and velocity (vlRTurn and vlVTurn). More...
void | setUpDownRay (double p, double r1, double r2)
| Sets the upgoing / downgoing flags for an integration between r1 and r2 for the input ray parameter p. If the ray turns between r1 and r2 in the layer, or the ray parameter is larger than the largest ray parameter evaluated at r1 and r2, or the r2 > r1 then the invalid ray flag is set. More...

## Protected Attributes
string | vlLayerName
| The descriptive name of the velocity layer. More...
string | vlPhaseType
| The phase type name ... either "P" or "S". More...
string | vlPhase
| The phase name of a ray that turns in the layer. This name is optional and used to define the phase unless overidden by vlPhaseUpper or vlPhaseLower for retrograde layers. More...
string | vlPhaseUpper
| The name of the phase for a ray that turns in the top half of a retro-grade layer. This name is optional and only used if assigned to a retrograde layer. More...
string | vlPhaseLower
| The name of the phase for a ray that turns in the bottom half of a retro-grade layer. This name is optional and only used if assigned to a retrograde layer. More...
string | vlPhaseIUpper
| The name of the diffracted phase for a ray that bottoms in the layer and uses the layers bottom velocity to travel along the layer boundary. This name is optional and only required if the phase is to be supported. More...
string | vlPhaseILower
| The name of the diffracted phase of a ray that bottoms in the layer and uses the next layers top velocity to travel along the layer boundary. This name is optional and only required if the phase is to be supported. More...
int | vlLayerType
| An integer value that describes the layer type. More...
bool | vlSplitLayer
| Boolean flag that is true if the velocity layer is a retrograde layer. More...
bool | vlInvalidRay
| Boolean flag that is true if the last distance / time evaluation for this velocity layer was invalid. More...
bool | vlPassingRay
| Boolean flag that is true if the last distance / time evaluation for this velocity layer was a passing ray. More...
bool | vlTurningRay
| Boolean flag that is true if the last distance / time evaluation for this velocity layer was a turning ray. More...
bool | vlPhaseUpperIDef
| Set to true if the upper diffracted phase for this layer is to be evaluated. More...
bool | vlPhaseLowerIDef
| Set to true if the lower diffracted phase for this layer is to be evaluated. More...
double | vlRt
| The layer top radius. More...
double | vlRb
| The layer bottom radius. More...
double | vlIRt
| The last integration top radius for this layer. More...
double | vlIRb
| The last integration bottom radius for this layer. More...
double | vlVt
| The layer top velocity. More...
double | vlVb
| The layer bottom velocity. More...
double | vlPt
| The layer top ray parameter (vlRt / vlVt). More...
double | vlPb
| The layer bottom ray parameter (vlRb / vlVb). More...
double | vlRTurn
double | vlVTurn
double | vlRLast
| Contains the last evaluated turning depth (or vlRb). More...
double | vlDistT
| The integrated distance to the top of the layer using the top ray parameter (vlPt or vlPmin if the layer is partially shadowed). More...
double | vlDistB
| The integrated distance to the bottom of the layer using the bottom ray parameter (vlPb or vlPmin if the layer is partially shadowed). More...
double | vldDistdP_T
| The derivative of distance wrt. the ray parameter at the top of the layer. More...
double | vldDistdP_B
| The derivative of distance wrt. the ray parameter at the bottom of the layer. More...
double | vlPmin
| The minimum allowed valid ray parameter that marks a passing limit in the layer. If vlPmin >= vlPt then all rays can penentrate the layer. If vlPMin < vlPb then the layer is a shadow layer and only passing rays (p < vlPb) can pass. If in between then vlPmin marks the boundary where a valid turning ray is allowed and a bounding shadow region exists above or below vlPmin. More...
double | vlPCrit
| The ray parameter that gives the distance minimum of a retrograde layer. If the layer is not retrograde this value is ignored. More...
double | vlDistCrit
| The distance to the minimum of the retrograde layer if the layer is retrograde. Otherwise ignored. More...

## Detailed Description

VL::VelocityIntegrate<VL>::TPVelocityLayer. VL contains the definition of the velocity function for the layer which is evaluated using the overloaded operator ().

    virtual double  operator()(double r);

VL also contains the definition for retrieving the radius in the layer given an input ray parameter.

    virtual double  rAtP(double p);

If the distance and or time functions can be evaluated analytically then they are also defined in VL which will override the default numerical versions of at run time.

    virtual double integrateDistance(double p, double r,
                                     bool r_open = false);
    virtual double integrateTime(double p, double r);

The VelocityIntegrate<VL> template object is used to exclusively numerically integrate the distance and time functions if analytic versions were not provided in the VL defintion. A template is used to avoid virtual pointer traversal during the numerical integration process which can evaluate the integrand many hundreds of times per integration.

This object, the base class TPVelocityLayer, contains the bulk of the contents of the commonality shared between all velocity layers including a descriptive name, a phase name breakdown, the radius, ray parameter, velocity, distance to, and distance/ray parameter derivatives of the layer defined at the top and bottom, layer type designations, retrograde definitions, and current processing defintions for the layer including the last ray parameter used to integrate distance and time and the results of the integration.

## Constructor & Destructor Documentation

taup::TPVelocityLayer::TPVelocityLayer | ( |  | ) |
| inline

taup::TPVelocityLayer::TPVelocityLayer | ( | double | rt,
|  | double | rb,
|  | const string & | layrnam
| ) |  |
| inline

Standard constructor. Sets top and bottom layer radius to rt and rb.

taup::TPVelocityLayer::TPVelocityLayer | ( | const TPVelocityLayer & | vl | ) |
| inline

virtual taup::TPVelocityLayer::~TPVelocityLayer | ( |  | ) |
| inlinevirtual

## Member Function Documentation

virtual int taup::TPVelocityLayer::bufferSize | ( |  | ) | const
| inlinevirtual

Used to calculate the size of a DataBuffer required to contain all of the data defined for a TPVelocityLayer object.

Reimplemented in taup::VelocityCubic, taup::VelocityQuadratic, taup::VelocityLinear, taup::VelocityPower, and taup::VelocityConst.

static string taup::TPVelocityLayer::class_name | ( |  | ) |
| inlinestatic

virtual int taup::TPVelocityLayer::classSize | ( |  | ) | const
| inlinevirtual

Reimplemented in taup::VelocityCubic, taup::VelocityQuadratic, taup::VelocityLinear, taup::VelocityPower, and taup::VelocityConst.

virtual void taup::TPVelocityLayer::deserialize | ( | DataBuffer & | buffer | ) |
| inlinevirtual

Used to read the contents of a TPVelocityLayer object from the input DataBuffer object buffer.

Reimplemented in taup::VelocityCubic, taup::VelocityQuadratic, taup::VelocityLinear, taup::VelocityPower, and taup::VelocityConst.

virtual string taup::TPVelocityLayer::get_class_name | ( |  | ) | const
| inlinevirtual

Reimplemented in taup::VelocityCubic, taup::VelocityQuadratic, taup::VelocityLinear, taup::VelocityPower, and taup::VelocityConst.

double taup::TPVelocityLayer::getdDistdPB | ( |  | ) | const
| inline

double taup::TPVelocityLayer::getdDistdPT | ( |  | ) | const
| inline

double taup::TPVelocityLayer::getDistB | ( |  | ) | const
| inline

double taup::TPVelocityLayer::getDistCrit | ( |  | ) | const
| inline

Returns the distance to the retrograde minimum if the layer is a retrograde layer. Otherwise -1.0 is returned.

double taup::TPVelocityLayer::getDistT | ( |  | ) | const
| inline

const string& taup::TPVelocityLayer::getLayerName | ( |  | ) | const
| inline

int taup::TPVelocityLayer::getLayerType | ( |  | ) | const
| inline

Returns the layer type. 0 = "Turning Layer" 1 = "Top Shadow, Bottom Turning" 2 = "Top Turning, Bottom Shadow" 3 = "Shadow Layer"

double taup::TPVelocityLayer::getPb | ( |  | ) | const
| inline

double taup::TPVelocityLayer::getPCrit | ( |  | ) | const
| inline

Returns the ray parameter that gives the retrograde minimum distance if the layer is a retrograde layer. Otherwise -1.0 is returned.

const string& taup::TPVelocityLayer::getPhaseName | ( |  | ) | const
| inline

const string& taup::TPVelocityLayer::getPhaseNameDiff | ( |  | ) | const
| inline

const string& taup::TPVelocityLayer::getPhaseNameDiffLower | ( |  | ) | const
| inline

const string& taup::TPVelocityLayer::getPhaseNameLower | ( |  | ) | const
| inline

const string& taup::TPVelocityLayer::getPhaseNameUpper | ( |  | ) | const
| inline

const string& taup::TPVelocityLayer::getPhaseType | ( |  | ) | const
| inline

double taup::TPVelocityLayer::getPmin | ( |  | ) | const
| inline

double taup::TPVelocityLayer::getPt | ( |  | ) | const
| inline

double taup::TPVelocityLayer::getRb | ( |  | ) | const
| inline

double taup::TPVelocityLayer::getRt | ( |  | ) | const
| inline

double taup::TPVelocityLayer::getTurningRadius | ( |  | ) | const
| inline

/brief Returns the last evaluated turning radius for this layer. If the last evaluation was a passing ray then the bottom radius is returned. One must inspect the boolean function isTurning() to determine if the ray really turned in the layer.

double taup::TPVelocityLayer::getTurningVelocity | ( |  | ) | const
| inline

/brief Returns the last evaluated turning velocity for this layer. If the last evaluation was a passing ray then the bottom velocity is returned. One must inspect the boolean function isTurning() to determine if the ray really turned in the layer.

double taup::TPVelocityLayer::getVb | ( |  | ) | const
| inline

double taup::TPVelocityLayer::getVt | ( |  | ) | const
| inline

void taup::TPVelocityLayer::init | ( |  | ) |
| inline

double taup::TPVelocityLayer::integDistance | ( | double | p,
|  | double | r = `-1.0`
| ) |  |
| inline

double taup::TPVelocityLayer::integDistance | ( | double | p,
|  | double | r1,
|  | double | r2
| ) |  |
| inline

virtual double taup::TPVelocityLayer::integrateDistance | ( | double | p,
|  | double | ra,
|  | bool | r_open = `false`
| ) |  |
| virtual

If the flag r_open is true and a numerical integration is to be performed then the open limit integration function IntegrateFunction::integrateAOpenS(...) is called. Otherwise the closed form function, IntegrateFunction::integrateClosed(...), is used. If the velocity model is defined analytically then the flag is ignored.

Reimplemented in taup::VelocityLinear, taup::VelocityPower, taup::VelocityConst, taup::VelocityIntegrate< V >, taup::VelocityIntegrate< VelocityCubic >, taup::VelocityIntegrate< VelocityConst >, taup::VelocityIntegrate< VelocityPower >, taup::VelocityIntegrate< VelocityLinear >, and taup::VelocityIntegrate< VelocityQuadratic >.

virtual double taup::TPVelocityLayer::integrateDistance | ( | double | p,
|  | double | ra,
|  | double | rb,
|  | bool | r_open = `false`
| ) |  |
| virtual

If the flag r_open is true and a numerical integration is to be performed then the open limit integration function IntegrateFunction::integrateAOpenS(...) is called. Otherwise the closed form function, IntegrateFunction::integrateClosed(...), is used. If the velocity model is defined analytically then the flag is ignored.

Reimplemented in taup::VelocityLinear, taup::VelocityPower, taup::VelocityConst, taup::VelocityIntegrate< V >, taup::VelocityIntegrate< VelocityCubic >, taup::VelocityIntegrate< VelocityConst >, taup::VelocityIntegrate< VelocityPower >, taup::VelocityIntegrate< VelocityLinear >, and taup::VelocityIntegrate< VelocityQuadratic >.

virtual double taup::TPVelocityLayer::integrateTime | ( | double | p,
|  | double | ra
| ) |  |
| virtual

Reimplemented in taup::VelocityPower, taup::VelocityConst, taup::VelocityIntegrate< V >, taup::VelocityIntegrate< VelocityCubic >, taup::VelocityIntegrate< VelocityConst >, taup::VelocityIntegrate< VelocityPower >, taup::VelocityIntegrate< VelocityLinear >, and taup::VelocityIntegrate< VelocityQuadratic >.

virtual double taup::TPVelocityLayer::integrateTime | ( | double | p,
|  | double | ra,
|  | double | rb
| ) |  |
| virtual

Reimplemented in taup::VelocityPower, taup::VelocityConst, taup::VelocityIntegrate< V >, taup::VelocityIntegrate< VelocityCubic >, taup::VelocityIntegrate< VelocityConst >, taup::VelocityIntegrate< VelocityPower >, taup::VelocityIntegrate< VelocityLinear >, and taup::VelocityIntegrate< VelocityQuadratic >.

double taup::TPVelocityLayer::integTime | ( | double | p,
|  | double | r = `-1.0`
| ) |  |
| inline

double taup::TPVelocityLayer::integTime | ( | double | p,
|  | double | r1,
|  | double | r2
| ) |  |
| inline

bool taup::TPVelocityLayer::invalidRay | ( |  | ) | const
| inline

bool taup::TPVelocityLayer::isPhaseDiffDefined | ( |  | ) | const
| inline

bool taup::TPVelocityLayer::isPhaseDiffLowerDefined | ( |  | ) | const
| inline

bool taup::TPVelocityLayer::isSplitLayer | ( |  | ) | const
| inline

virtual bool taup::TPVelocityLayer::isTimeIntegralTau | ( |  | ) | const
| inlinevirtual

Reimplemented in taup::VelocityPower, and taup::VelocityConst.

virtual bool taup::TPVelocityLayer::isVelocityConstant | ( |  | ) | const
| inlinevirtual

Virtual function that returns False for each model type. These functions are defined in each model type to return true.

Reimplemented in taup::VelocityConst.

virtual bool taup::TPVelocityLayer::isVelocityCubic | ( |  | ) | const
| inlinevirtual

Reimplemented in taup::VelocityCubic.

virtual bool taup::TPVelocityLayer::isVelocityLinear | ( |  | ) | const
| inlinevirtual

Reimplemented in taup::VelocityLinear.

virtual bool taup::TPVelocityLayer::isVelocityPowerLaw | ( |  | ) | const
| inlinevirtual

Reimplemented in taup::VelocityPower.

virtual bool taup::TPVelocityLayer::isVelocityQuadratic | ( |  | ) | const
| inlinevirtual

Reimplemented in taup::VelocityQuadratic.

static TPVelocityLayer* taup::TPVelocityLayer::newModelCopy | ( | TPVelocityLayer * | tpvl | ) |
| static

static TPVelocityLayer* taup::TPVelocityLayer::newModelCopy | ( | const string & | cnam,
|  | DataBuffer & | buffer
| ) |  |
| static

virtual double taup::TPVelocityLayer::operator() | ( | double | r | ) |
| virtual

Standard operator() overload which returns the velocity at radius r. The radius is defined from the center of the Earth.

Reimplemented in taup::VelocityCubic, taup::VelocityQuadratic, taup::VelocityLinear, taup::VelocityPower, and taup::VelocityConst.

TPVelocityLayer& taup::TPVelocityLayer::operator= | ( | const TPVelocityLayer & | vl | ) |
| inline

bool taup::TPVelocityLayer::passingRay | ( |  | ) | const
| inline

double taup::TPVelocityLayer::pAtR | ( | double | r | ) |
| inline

Standard function that returns the turning ray parameter as a function of radius r. The turning ray parameter is defined as p = r / v(r) where v(r) is the radial velocity.

virtual double taup::TPVelocityLayer::rAtP | ( | double | p | ) |
| virtual

Standard function that returns the radius as function of the turning ray parameter p. The turning ray parameter is defined as p = r / v(r) where v(r) is the radial velocity

Reimplemented in taup::VelocityCubic, taup::VelocityQuadratic, taup::VelocityLinear, taup::VelocityPower, and taup::VelocityConst.

virtual void taup::TPVelocityLayer::serialize | ( | DataBuffer & | buffer | ) |
| inlinevirtual

Used to write the contents of a TPVelocityLayer object into the input DataBuffer object buffer.

Reimplemented in taup::VelocityCubic, taup::VelocityQuadratic, taup::VelocityLinear, taup::VelocityPower, and taup::VelocityConst.

void taup::TPVelocityLayer::setdDistdPB | ( | double | dDdP | ) |
| inline

void taup::TPVelocityLayer::setdDistdPT | ( | double | dDdP | ) |
| inline

void taup::TPVelocityLayer::setDistB | ( | double | d | ) |
| inline

void taup::TPVelocityLayer::setDistT | ( | double | d | ) |
| inline

void taup::TPVelocityLayer::setLayerType | ( | int | lt | ) |
| inline

Sets the layer type: 0 = "Turning Layer" 1 = "Top Shadow, Bottom Turning" 2 = "Top Turning, Bottom Shadow" 3 = "Shadow Layer"

void taup::TPVelocityLayer::setPhaseDiffDef | ( | bool | def | ) |
| inline

void taup::TPVelocityLayer::setPhaseDiffLowerDef | ( | bool | def | ) |
| inline

void taup::TPVelocityLayer::setPhaseName | ( | const string & | name | ) |
| inline

void taup::TPVelocityLayer::setPhaseNameDiff | ( | const string & | name | ) |
| inline

void taup::TPVelocityLayer::setPhaseNameDiffLower | ( | const string & | name | ) |
| inline

void taup::TPVelocityLayer::setPhaseNameLower | ( | const string & | name | ) |
| inline

void taup::TPVelocityLayer::setPhaseNameUpper | ( | const string & | name | ) |
| inline

void taup::TPVelocityLayer::setPhaseType | ( | const string & | phtype | ) |
| inline

void taup::TPVelocityLayer::setPhaseTypeP | ( |  | ) |
| inline

void taup::TPVelocityLayer::setPhaseTypeS | ( |  | ) |
| inline

void taup::TPVelocityLayer::setPmin | ( | double | pmin | ) |
| inline

void taup::TPVelocityLayer::setRay | ( | double | p | ) |
| inlineprotected

void taup::TPVelocityLayer::setSplitLayer | ( | double | pcrit,
|  | double | dcrit
| ) |  |
| inline

void taup::TPVelocityLayer::setUpDownRay | ( | double | p,
|  | double | r1,
|  | double | r2
| ) |  |
| inlineprotected

virtual void taup::TPVelocityLayer::toStream | ( | ostream & | os,
|  | string | indent
| ) |  | const
| virtual

Reimplemented in taup::VelocityCubic, taup::VelocityQuadratic, taup::VelocityLinear, taup::VelocityPower, and taup::VelocityConst.

string taup::TPVelocityLayer::toString | ( |  | ) | const

bool taup::TPVelocityLayer::turningRay | ( |  | ) | const
| inline

virtual void taup::TPVelocityLayer::writeNormRadius | ( | ostream & | os | ) | const
| inlinevirtual

Reimplemented in taup::VelocityCubic, taup::VelocityQuadratic, and taup::VelocityLinear.

virtual void taup::TPVelocityLayer::writeVelocity | ( | ostream & | os | ) | const
| virtual

Reimplemented in taup::VelocityCubic, taup::VelocityQuadratic, taup::VelocityLinear, taup::VelocityPower, and taup::VelocityConst.

## Member Data Documentation

double taup::TPVelocityLayer::vldDistdP_B
| protected

double taup::TPVelocityLayer::vldDistdP_T
| protected

double taup::TPVelocityLayer::vlDistB
| protected

double taup::TPVelocityLayer::vlDistCrit
| protected

double taup::TPVelocityLayer::vlDistT
| protected

bool taup::TPVelocityLayer::vlInvalidRay
| protected

double taup::TPVelocityLayer::vlIRb
| protected

double taup::TPVelocityLayer::vlIRt
| protected

string taup::TPVelocityLayer::vlLayerName
| protected

int taup::TPVelocityLayer::vlLayerType
| protected

Valid types include:

    0: A Turning Layer ... A ray can turn anywhere within the layer
       between ray parameter values of vlPt to vlPb.
    1: A Bottom Turning Layer ... A ray can turn in the bottom half of
       the layer between vlPmin and vlPb but is shadowed (excluded) in
       the upper part of the layer.
    2: A Top Turning Layer ... A ray can turn in the top half of the
       layer between vlPt and vlPmin but is shadowed (excluded) in the
       lower part of the layer. And,
    3: A Shadow Layer ... No valid ray turns anywhere within the layer.

bool taup::TPVelocityLayer::vlPassingRay
| protected

double taup::TPVelocityLayer::vlPb
| protected

double taup::TPVelocityLayer::vlPCrit
| protected

string taup::TPVelocityLayer::vlPhase
| protected

string taup::TPVelocityLayer::vlPhaseILower
| protected

string taup::TPVelocityLayer::vlPhaseIUpper
| protected

string taup::TPVelocityLayer::vlPhaseLower
| protected

bool taup::TPVelocityLayer::vlPhaseLowerIDef
| protected

string taup::TPVelocityLayer::vlPhaseType
| protected

string taup::TPVelocityLayer::vlPhaseUpper
| protected

bool taup::TPVelocityLayer::vlPhaseUpperIDef
| protected

double taup::TPVelocityLayer::vlPmin
| protected

double taup::TPVelocityLayer::vlPt
| protected

double taup::TPVelocityLayer::vlRb
| protected

double taup::TPVelocityLayer::vlRLast
| protected

double taup::TPVelocityLayer::vlRt
| protected

double taup::TPVelocityLayer::vlRTurn
| protected

bool taup::TPVelocityLayer::vlSplitLayer
| protected

bool taup::TPVelocityLayer::vlTurningRay
| protected

double taup::TPVelocityLayer::vlVb
| protected

double taup::TPVelocityLayer::vlVt
| protected

double taup::TPVelocityLayer::vlVTurn
| protected

The documentation for this class was generated from the following file:

- /nfs/tonto2/devlpool/sballar/RSTT/SLBM_Root.3.0.5/install/SLBM_Root.3.0.5.Linux/SLBM/include/TPVelocityModels.h